//	Copyright  1995 Apple Computer, Inc. All rights reserved.
//	Release Version:	$ 1.0 d11 $

//=======================================================================
#ifndef _DATAFRAME_
#include "DataFrm.h"			// CDataFrame
#endif

#ifndef DATAPRT_H
#include "DataPrt.h"			// CDataPart
#endif

#ifndef PIZZA_H
#include "Pizza.h"				//  CPizza
#endif

// ----- Framework Layer -----
#ifndef FWUTIL_H
#include "FWUtil.h"				// FW_CFacetContext, FW_Beep()
#endif

// ----- Graphic Includes -----
#ifndef FWRECT_H
#include <FWRect.h>				// FW_CRect
#endif

#ifndef FWRECSHP_H
#include "FWRecShp.h"			// FW_CRectShape
#endif

//========================================================================================
#ifdef FW_BUILD_MAC
#pragma segment Data
#endif

//========================================================================================
CDataFrame::CDataFrame(Environment* ev, ODFrame* odFrame, 
									FW_CPresentation* presentation, CDataPart* dataPart)
  : FW_CFrame(ev, odFrame, presentation, dataPart),
  	fDataPart(dataPart)
{
}

//----------------------------------------------------------------------------------------
CDataFrame::~CDataFrame()
{
}

//----------------------------------------------------------------------------------------
void 
CDataFrame::Draw(Environment *ev, ODFacet* odFacet, ODShape* invalidShape)	// Override
{
	FW_CViewContext context(ev, this, odFacet, invalidShape);
	FW_CRect box = this->GetBounds(ev);	
	FW_CRectShape::RenderRect(context, box, FW_kFill, FW_kRGBLightGray);
	
	// draw pizzas
	FW_CPrivOrderedCollection* list = fDataPart->MyGetPizzaList();
	FW_COrderedCollectionIterator iter(list);
	CPizza	*pizza;
	for (pizza = (CPizza*) iter.First(); iter.IsNotComplete(); pizza = (CPizza*) iter.Next())
		pizza->Draw(context);
}

//----------------------------------------------------------------------------------------
FW_Boolean 
CDataFrame::DoMouseDown(Environment* ev, const FW_CMouseEvent& theMouseEvent)
{	
	FW_UNUSED(ev);
	FW_UNUSED(theMouseEvent);
	fDataPart->MyIncrement();	// count number of mouse clicks 
	fDataPart->MyInvalidatePresentation(ev);	
	return TRUE;				// we handled event
}
